/* $Id: ClientFeeds.h 2426 2012-03-18 01:37:51Z IMPOMEZIA $
 * IMPOMEZIA Simple Chat
 * Copyright © 2008-2012 IMPOMEZIA <schat@impomezia.com>
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef CLIENTFEEDS_H_
#define CLIENTFEEDS_H_

#include <QObject>
#include <QVariant>

#include "schat.h"

class FeedNotice;

namespace Hooks
{
  class Feeds;
}

class SCHAT_EXPORT ClientFeeds : public QObject
{
  Q_OBJECT

public:
  ClientFeeds(QObject *parent = 0);
  bool headers(const QByteArray &id);
  bool query(const QString &name, const QString &action, const QVariantMap &json = QVariantMap());
  bool query(const QByteArray &id, const QString &name, const QString &action, const QVariantMap &json = QVariantMap());
  bool request(const QByteArray &id, const QString &command, const QString &name, const QVariantMap &json = QVariantMap());
  bool revert(const QByteArray &id, const QString &name, qint64 rev);
  inline Hooks::Feeds *hooks() const { return m_hooks; }

private slots:
  void notice(int type);

private:
  FeedNotice *m_packet;     ///< Текущий прочитанный пакет.
  Hooks::Feeds *m_hooks;    ///< Хуки.
};

#endif /* CLIENTFEEDS_H_ */
