/* $Id: MessageAlert.cpp 2152 2012-01-15 10:38:13Z IMPOMEZIA $
 * IMPOMEZIA Simple Chat
 * Copyright © 2008-2012 IMPOMEZIA <schat@impomezia.com>
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#include "alerts/MessageAlert.h"
#include "messages/ChannelMessage.h"
#include "net/packets/MessageNotice.h"
#include "net/SimpleID.h"

MessageAlert::MessageAlert(const ChannelMessage &message)
  : Alert(PublicMessage, message.packet()->id(), message.packet()->date())
{
  m_tab = message.tab();

  if (SimpleID::typeOf(m_tab) == SimpleID::UserId)
    m_type = PrivateMessage;

  m_data["Message"] = message.data();
}
